array = ["Bilbo", "Gandalf", "Nazgul"];
array.forEach((item, index, array) =>{
    console.log(`${item} is at index ${index} in ${array}`)
});

console.log(`arr.indexOf(Bilbo): ${array.indexOf("Bilbo")}`)
console.log(`arr.indexOf(Bilbo): ${array.includes("Bilbo")}`)

let fruits = ['Apple', 'Orange', 'Apple']
console.log(`fruits.indexOf('Apple'): ${fruits.indexOf('Apple')}`)
console.log(`fruits.lastIndexOf('Apple'): ${fruits.lastIndexOf('Apple')}`)

// arr.find(fn)
let users = [
    {id: 1, name: "xingzhesun"},
    {id: 2, name: "zhexingsun"},
    {id: 3, name: "sunxingzhe"},
];

let user1 = users.find(item => item.id == 1);
let user2 = users.findLastIndex(item => item.id == 1);
console.log(user1.name);
console.log(user2.name);

// arr.filter
let someUsers = users.filter(user => user.id < 3);
console.log(someUsers)
someUsers = users.filter(function(item, index, array){
    if (item.id < 3){
        return true;
    }
})
console.log(someUsers);

// arr.map(fn)
let lengths = array.map(item=>item.length);
console.log(lengths);

// arr.sort(fn)
function compare(a, b){
    if (a > b) return 1;
    if (a == b) return 0;
    if (a < b) return -1;
}

arr = [15, 2 ,1];
console.log(`arr.sort(): ${arr.sort(compare)}`);
console.log(`arr.sort(): ${arr.sort((a,b) => a - b)}`);

let countries = ['Österreich', 'Andorra', 'Vietnam'];
console.log(countries.sort((a,b) => a.localeCompare(b)))